<template>
  <div class="airportInfo scroll-y">
    <div class="wrap">
      <Minheader :is-auth="true" :is-statuser="true" powerData="new_node_button" @addForm="addForm">
        <template #header>
          <div class="status flex-wrap">
            <div class="manageTitle">节点信息维护</div>
          </div>
        </template>
      </Minheader>
      <div class="app-containers">
        <DataTable :tableHeader="tableCols" :tableData="tableData" :tableBtnGroup="tableBtnGroup" :tableProperty="{ rowKey: 'ID' }" @btnClick="btnClick" />
      </div>
      <Dialog :flag="flag" :type="type" :msgTitle="msgTitle" :delName="tableForm.nodeName" @resetForm="resetForm" @delRest="delRest" @submitForm="submitForm" @delRemove="delRemove">
        <div class="diacont">
          <el-form :model="tableForm" :rules="formRules" ref="deployNodeForm">
            <el-row :gutter="24">
              <el-col>
                <el-form-item label="节点ID" size="default" prop="nodeID" :rules="formRules.isNotNull">
                  <el-input v-model="tableForm.nodeID" placeholder="请输入节点ID" />
                </el-form-item>
              </el-col>
              <el-col>
                <el-form-item label="节点名称" size="default" prop="nodeName" :rules="formRules.isNotNull">
                  <el-input v-model="tableForm.nodeName" placeholder="请输入名称" />
                </el-form-item>
              </el-col>
              <el-col>
                <el-form-item label="节点编码" size="default" prop="nodeCode" :rules="formRules.isNotNull">
                  <el-input v-model="tableForm.nodeCode" placeholder="请输入航站名称" />
                </el-form-item>
              </el-col>
              <el-col>
                <el-form-item label="备注" size="default">
                  <el-input type="textarea" v-model="tableForm.nodeDescribe" placeholder="请输入备注" />
                </el-form-item>
              </el-col>
            </el-row>
          </el-form>
        </div>
      </Dialog>
    </div>
  </div>
</template>
<script setup lang="ts">
import DataTable from "@/components/tableTemp/index.vue";
import Minheader from "@/components/minheader/index.vue";
import Dialog from "@/components/dialog/index.vue";
import { Query, GeneralDataReception } from "@/api/webApi";
import { ElMessage } from "element-plus";
const formRules = useElement().formRules;
const page = ref<number>(0); //分页参数
const dataContent = ref<object>({});
const noMore = ref<boolean>(false);
const rowTitle = ref<string>("");
const tableCols = ref<any>([]); //表头数据
const serviceId = ref<any>("");
const tableObj = ref({}); //增删改数据缓存
const flag = ref<boolean>(false); //弹窗开关
const type = ref<string>(""); //判断是否删除
const msgTitle = ref<string>("新增节点信息维护"); //弹窗标题
const tableColsCopys = reactive<Object>({}); //弹窗
const tableForm = reactive<any>({
  nodeID: "",
  nodeName: "",
  nodeCode: "",
  nodeDescribe: "",
  event: "",
}); //弹窗内容
//列表
const tableData = ref<any>([]);
//表头
const state = reactive({
  list: [
    { label: "名称", key: "name" },
    { label: "编码", key: "china" },
    { label: "描述", key: "englin" },
    { label: "排序", key: "two" },
  ],
  listLoading: true,
});
const tableBtnGroup = ref([
  {
    name: "编辑",
    className: "editBtn",
    param: 2,
    is: "node_editing_button",
  },
  {
    name: "删除",
    className: "delBtn",
    param: 3,
    is: "node_deletion_button",
  },
]);
//新增
const addForm = () => {
  msgTitle.value = "新增节点信息维护";
  flag.value = true;
  type.value = "";
  tableForm.event = 1;
};
//取消
const resetForm = () => {
  deployNodeForm.value?.resetFields();
  flag.value = false;
  // tableForm.nodeID = "";
  // tableForm.nodeName = "";
  // tableForm.nodeCode = "";
  // tableForm.nodeDescribe = "";
};
//编辑
const editDialog = (data) => {
  msgTitle.value = "编辑节点信息维护";
  flag.value = true;
  type.value = "";
  tableForm.name = data.name;
  tableForm.china = data.china;
  tableForm.englin = data.englin;
};
//删除
const eleDialog = () => {
  msgTitle.value = "删除节点信息维护";
  flag.value = true;
  type.value = "del";
};
const delRemove = () => {
  tableForm.event = 3;
  generalDataReception(tableForm);
};
//删除
const delRest = () => {
  flag.value = false;
};
//编辑-删除
const btnClick = (row, index, param) => {
  if (param === 2) {
    msgTitle.value = "编辑节点信息维护";
    flag.value = true;
    type.value = "";
    tableForm.event = 2;
    tableForm.nodeID = index.nodeID;
    tableForm.nodeName = index.nodeName;
    tableForm.nodeCode = index.nodeCode;
    tableForm.nodeDescribe = index.nodeDescribe;
  } else if (param === 3) {
    msgTitle.value = "删除节点信息维护";
    flag.value = true;
    type.value = "del";
    tableForm.event = 3;
    tableForm.nodeID = index.nodeID;
    tableForm.nodeName = index.nodeName;
    tableForm.nodeCode = index.nodeCode;
    tableForm.nodeDescribe = index.nodeDescribe;
  } else if (param === 4) {
  }
};
//获取表格数据
const getQuery = async () => {
  try {
    const { code, returnData } = await Query({
      id: DATACONTENT_ID.deployNodeId,
      needPage: ++page.value,
      dataContent: Object.values(dataContent.value),
    });
    if (code === "0") {
      if (returnData.listValues.length === 0) {
        page.value--;
        noMore.value = true;
      }
      const titleColumn = returnData.columnSet.find(
        (item) => item.needShow === 1
      );
      if (titleColumn) {
        rowTitle.value = titleColumn.columnName;
      }
      tableData.value.push(...returnData.listValues);
      tableCols.value = returnData.columnSet;
      tableCols.value.forEach((element) => {
        element.label = element.columnLabel;
        element.key = element.columnName;
        // if (element.columnName === "queryTemplate") {
        //   element.width = "300px";
        // }
      });
      serviceId.value = returnData.submitID;
    } else {
      page.value--;
    }
  } catch (error) {
    page.value--;
  }
};
//确认提交
const deployNodeForm: any = ref(null);
const submitForm = () => {
  deployNodeForm.value.validate((valid: any) => {
    if (valid) {
      generalDataReception(tableForm);
    } else {
      return false;
    }
  });
};
const resetTable = () => {
  page.value = 0;
  noMore.value = false;
  tableData.value = [];
};

const btnAuthMap = [, 'new_node_button', 'node_editing_button', 'node_deletion_button']
//新增-编辑-删除
const generalDataReception = async (data) => {
  try {
    data = {
      ...data,
    };
    const { code } = await GeneralDataReception({
      serviceId: serviceId.value,
      dataContent: JSON.stringify(data),
      btnAuth: btnAuthMap[data.event]
    });
    if (code == 0) {
      ElMessage.success(`操作成功`);
      // this.$message.success("操作成功");
      resetTable();
      getQuery();
      resetForm();
      flag.value = false;
      // rmFlag.value = false;
      tableObj.value = {};
      // this.$router.go(0);
    } else {
      ElMessage.error(`操作失败`);
      // this.$message.error("操作失败");
      // this.flag = false;
      // this.rmFlag = false;
      tableObj.value = {};
      resetForm();
    }
  } catch (error) {
    flag.value = false;
    //  rmFlag.value = false;
    tableObj.value = {};
    resetForm();
  }
};
getQuery();
</script>
<style lang="scss" scoped>
::v-deep .el-form-item__label {
  width: 80px;
}
</style>
